Index: XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp
===================================================================
--- XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp	(revision 624)
+++ XIOS/trunk/src/transformation/generic_algorithm_transformation.cpp	(revision 624)
@@ -0,0 +1,59 @@
+/*!
+   \file generic_algorithm_transformation.hpp
+   \author Ha NGUYEN
+   \since 14 May 2015
+   \date 09 June 2015
+
+   \brief Interface for all transformation algorithms.
+ */
+#include "generic_algorithm_transformation.hpp"
+
+namespace xios {
+
+CGenericAlgorithmTransformation::CGenericAlgorithmTransformation()
+ : transformationMapping_()
+{
+}
+
+/*!
+  This function computes the global indexes of grid source, which the grid destination is in demand.
+  \param[in] elementPositionInGrid position of an element in a grid .E.g: if grid is composed of domain and axis (in order),
+                then position of axis in grid is 2 (since a domain is considered to contain 2 elements (axis)
+  \param[in] gridDestGlobalDim global size of each dimension of grid source (all dimension must have the same size except of the one on which transformation is performed)
+  \param[in] globalIndexGridDestSendToServer global index of grid destination on the current client to send to server
+  \param[in/out] globaIndexMapFromDestToSource mapping between transformed global index of grid destination
+                    and the demanded global index of grid source
+*/
+void CGenericAlgorithmTransformation::computeGlobalSourceIndex(int elementPositionInGrid,
+                                                             const std::vector<int>& gridDestGlobalDim,
+                                                             const CArray<size_t,1>& globalIndexGridDestSendToServer,
+                                                             std::map<size_t, std::set<size_t> >& globaIndexMapFromDestToSource)
+{
+  std::map<int, std::vector<int> >::const_iterator itbTransMap = transformationMapping_.begin(),
+                                                   itTransMap = itbTransMap,
+                                                   iteTransMap = transformationMapping_.end();
+  std::vector<int>::const_iterator itbVec, itVec, iteVec;
+  std::vector<CArray<size_t,1> > globalIndexSrcGrid; //((itTransMap->second).size());
+  CArray<size_t,1> globalIndexDestGrid;
+  for (itTransMap = itbTransMap; itTransMap != iteTransMap; ++itTransMap)
+  {
+
+    this->computeGlobalIndexFromGlobalIndexElement(itTransMap->first,
+                                                   itTransMap->second,
+                                                   elementPositionInGrid,
+                                                   gridDestGlobalDim,
+                                                   globalIndexGridDestSendToServer,
+                                                   globalIndexDestGrid,
+                                                   globalIndexSrcGrid);
+    size_t globalIndexSize = globalIndexDestGrid.numElements();
+    for (size_t idx = 0; idx < globalIndexSize; ++idx)
+    {
+      for (int i = 0; i < globalIndexSrcGrid.size(); ++i)
+      {
+        globaIndexMapFromDestToSource[globalIndexDestGrid(idx)].insert(globalIndexSrcGrid[i](idx));
+      }
+    }
+  }
+}
+
+}
Index: XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp
===================================================================
--- XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp	(revision 624)
+++ XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp	(revision 624)
@@ -0,0 +1,64 @@
+/*!
+   \file generic_algorithm_transformation.hpp
+   \author Ha NGUYEN
+   \since 14 May 2015
+   \date 09 June 2015
+
+   \brief Interface for all transformation algorithms.
+ */
+#ifndef __XIOS_GENERIC_ALGORITHM_TRANSFORMATION_HPP__
+#define __XIOS_GENERIC_ALGORITHM_TRANSFORMATION_HPP__
+
+#include <map>
+#include <vector>
+#include "array_new.hpp"
+
+namespace xios {
+  /*!
+  \class CGenericAlgorithmTransformation
+  This class defines the interface for all other inherted algorithms class
+  */
+class CGenericAlgorithmTransformation
+{
+public:
+  CGenericAlgorithmTransformation();
+
+  virtual ~CGenericAlgorithmTransformation() {}
+
+  void computeGlobalSourceIndex(int elementPositionInGrid,
+                                const std::vector<int>& gridDestGlobalDim,
+                                const CArray<size_t,1>& globalIndexGridDestSendToServer,
+                                std::map<size_t, std::set<size_t> >& globaIndexMapFromDestToSource);
+
+  /*!
+  Compute global index mapping from one element of destination grid to the corresponding element of source grid
+  */
+  virtual void computeIndexSourceMapping() = 0;
+
+protected:
+  /*!
+  Compute an array of global index from a global index on an element
+    \param[in] destGlobalIndex global index on an element of destination grid
+    \param[in] srcGlobalIndex global index(es) on an element of source grid (which are needed by one index on element destination)
+    \param[in] elementPositionInGrid position of the element in the grid (for example: a grid with one domain and one axis, position of domain is 1, position of axis is 2)
+    \param[in] gridDestGlobalDim dimension size of destination grid (it should share the same size for all dimension, maybe except the element on which transformation is performed)
+    \param[in] globalIndexGridDestSendToServer global index of destination grid which are to be sent to server(s)
+    \param[in/out] globalIndexDestGrid array of global index (for 2d grid, this array maybe a line, for 3d, this array may represent a plan). It should be preallocated
+    \param[in/out] globalIndexSrcGrid array of global index of source grid (for 2d grid, this array is a line, for 3d, this array represents a plan). It should be preallocated
+  */
+  virtual void computeGlobalIndexFromGlobalIndexElement(int destGlobalIndex,
+                                                        const std::vector<int>& srcGlobalIndex,
+                                                        int elementPositionInGrid,
+                                                        const std::vector<int>& gridDestGlobalDim,
+                                                        const CArray<size_t,1>& globalIndexGridDestSendToServer,
+                                                        CArray<size_t,1>& globalIndexDestGrid,
+                                                        std::vector<CArray<size_t,1> >& globalIndexSrcGrid) = 0;
+
+
+
+protected:
+  std::map<int, std::vector<int> > transformationMapping_;
+};
+
+}
+#endif // __XIOS_GENERIC_ALGORITHM_TRANSFORMATION_HPP__
